clear variables;
close all;
TrainX = [-1, -1, +1; -1, +1, +1; +1, -1, -1; ...
          -1, +1, -1; +1, -1, +1; +1, +1, -1];
TrainY = [0,0,0,1,1,1]';
TestX = TrainX;
TestY = TrainY;

N= size(TrainX,1);
X = TrainX(1:N,:);
t = TrainY(1:N);

NTest= size(TestX,1);
Xtest = TestX(1:NTest,:);
Ttest = TestY(1:NTest);
close all;

options.max_epochs = 20;
options.lr_milestone = 'iteration'; % 'effective_lr'
options.lr_start = 10;
options.lr_mult  = 1;
options.lr_staying_mult = 10;
options.cross_entropy_type = 'soft'; % 'hard'
options.weights_init_method = 'small_random'; %{'data_mean', 'small_random', 'kmeans', 'zero', 'load'}
options.dataset_name = '';
options.display_weights = 0;
options.rand_init_std = 0.5;
options.adjust_for_imbalance = 0;

repCount = 100;
errorTrajectory = zeros(repCount, options.max_epochs+1);
for i=1:repCount
    rng(i);
    [errorTrajectory(i,:),W,bias]=single_layer_competitive_cross_entropy(X,t,Xtest,Ttest, 2,3, options);
end
%errorTrajectory
mean(errorTrajectory(:,options.max_epochs+1))
std(errorTrajectory(:,options.max_epochs+1))
plot (mean(errorTrajectory));

figure;
y=mean(errorTrajectory);
e=std(errorTrajectory);
errorbar(0:options.max_epochs,y,e);