clear variables;
close all;

linewidth = 3;
options.max_epochs = 20;
options.lr_milestone = 'iteration'; % 'effective_lr'
options.lr_start = 10;
options.lr_mult  = 1;
options.lr_staying_mult = 10;
options.cross_entropy_type = 'soft'; % 'hard'
options.weights_init_method = 'small_random'; %{'data_mean', 'small_random', 'kmeans', 'zero', 'load'}
options.dataset_name = '';
options.display_weights = 0;
options.rand_init_std = 0.25;
options.adjust_for_imbalance = 0;
options.weight_decay = 0;

repCount = 100;

%%% xor problem
TrainX = [-1, -1; -1, +1; +1, -1; +1, +1];
TrainY = [0,1,1,0]';
TestX = TrainX;
TestY = TrainY;
c = 2;
M = 2;

errorTrajectory = zeros(repCount, options.max_epochs+1);
for i=1:repCount
    rng(i);
    [errorTrajectory(i,:),W,bias]=single_layer_competitive_cross_entropy(TrainX,TrainY,TestX,TestY, c,M, options);
end
errorTrajectory_xor = errorTrajectory;

%%% M&S-81 problem
TrainX = [-1, -1, +1; -1, +1, +1; +1, -1, -1; ...
          -1, +1, -1; +1, -1, +1; +1, +1, -1];
TrainY = [0,0,0,1,1,1]';
TestX = TrainX;
TestY = TrainY;
c = 2;
M = 3;

errorTrajectory = zeros(repCount, options.max_epochs+1);
for i=1:repCount
    rng(i);
    [errorTrajectory(i,:),W,bias]=single_layer_competitive_cross_entropy(TrainX,TrainY,TestX,TestY, c,M, options);
end
errorTrajectory_MandS = errorTrajectory;


%%% 3bitparity problem
TrainX = [-1, -1, -1; -1, -1, +1; -1, +1, -1; -1, +1, +1; ...
          +1, -1, -1; +1, -1, +1; +1, +1, -1; +1, +1, +1];
TrainY = [0,1,1,0,1,0,0,1]';
TestX = TrainX;
TestY = TrainY;
c = 2;
M = 4;

errorTrajectory = zeros(repCount, options.max_epochs+1);
for i=1:repCount
    rng(i);
    [errorTrajectory(i,:),W,bias]=single_layer_competitive_cross_entropy(TrainX,TrainY,TestX,TestY, c,M, options);
end
errorTrajectory_3bitparity = errorTrajectory;


% mean(errorTrajectory(:,options.max_epochs+1))
% std(errorTrajectory(:,options.max_epochs+1))
% sum (errorTrajectory(:,options.max_epochs+1)>0)
% plot (mean(errorTrajectory));

figure;
errorTrajectory = errorTrajectory_xor;
y=mean(errorTrajectory);
e=std(errorTrajectory);
errorbar(0:options.max_epochs,y,e,'LineWidth',linewidth);
xlabel('Epoch');
ylabel('Misclassification Error(%)');
title('Learning curve for the XOR problem averaged over 100 runs.')

figure;
errorTrajectory = errorTrajectory_MandS;
y=mean(errorTrajectory);
e=std(errorTrajectory);
errorbar(0:options.max_epochs,y,e,'LineWidth',linewidth);
xlabel('Epoch');
ylabel('Misclassification Error(%)');
title('Learning curve for the M&S''81 problem averaged over 100 runs.')
figure;
errorTrajectory = errorTrajectory_3bitparity;
y=mean(errorTrajectory);
e=std(errorTrajectory);
errorbar(0:options.max_epochs,y,e,'LineWidth',linewidth);
xlabel('Epoch');
ylabel('Misclassification Error(%)');
title('Learning curve for the 3bit parity problem averaged over 100 runs.');
